﻿Public Class Form1
    Private WithEvents myAlarmData As New OPCAlarmDataOnly.OASAlarmData
    Private m_DataTable As DataTable
    Private m_AlarmQueue As New Queue
    Private m_InTimer As Boolean = False

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        InitAlarmData()
    End Sub

    Private Sub InitAlarmData()
        ' Use this if you want to monitor one or more remote services.  The default is localhost only.
        ' myAlarmData.AlarmNetworkNodes

        myAlarmData.AlarmFilter.IncludeTagEvents = False
        myAlarmData.AlarmFilter.IncludeOPC = False
        myAlarmData.AlarmFilter.IncludeOperatorEvents = False
        myAlarmData.AlarmFilter.IncludeSystem = False
        myAlarmData.AlarmFilter.IncludeTagClient = False
        myAlarmData.AlarmFilter.MaximumPriority = 100000000
        myAlarmData.AlarmFilter.MinimumPriority = 0

        ' Use Groups in the AlarmFilter to specify alarms with only specific groups.  The default is all
        'Dim localAlarmGroups(2) As String
        'localAlarmGroups(0) = "Process"
        'localAlarmGroups(1) = "Tanks"
        'localAlarmGroups(2) = "Values"
        'myAlarmData.AlarmFilter.Groups = localAlarmGroups

        ' Another cool way to filter alarms.
        'myAlarmData.AlarmFilter.AlarmIDsThatStartWith = "StartTextOfAlarmIDIWantToInclude"

        myAlarmData.AlarmFilter.AlarmActive = True
        myAlarmData.AlarmFilter.AlarmActiveAcked = True
        myAlarmData.AlarmFilter.AlarmNotActive = True
        myAlarmData.AlarmFilter.AlarmNotActiveAcked = True

        ' Returns a DataTable with all of the alarms and continues to update as new alarms arrive
        m_DataTable = myAlarmData.GetAlarmDataTable
        DataGridView1.DataSource = m_DataTable

        ' You can use StopRuntime to stop realtime alarms.
        myAlarmData.StartRuntime()
    End Sub

    Private Sub myAlarmData_AlarmsAdded(NetworkNodes() As String, RemoteSCADAHostingNames() As String, AlarmIDs() As String, AlarmTypes() As String, Groups() As String, Priorities() As Integer, AlarmTexts() As String, Active() As Boolean, Acked() As Boolean, DelayTimes() As Integer, AlarmValues() As Double, ClearedValues() As Double, AlarmDateTimes() As Date, ClearedDateTimes() As Date, AckedDateTimes() As Date, AckedUsers() As String, Units() As String) Handles myAlarmData.AlarmsAdded
        Dim localIndex As Int32
        ' Use a Queue so you can process the incoming alarms on you own threads without cross threading
        SyncLock m_AlarmQueue.SyncRoot
            For localIndex = 0 To AlarmIDs.GetLength(0) - 1
                m_AlarmQueue.Enqueue(New ClassAlarmData(AlarmIDs(localIndex), Acked(localIndex), Active(localIndex), AlarmTexts(localIndex), AlarmDateTimes(localIndex), AlarmTypes(localIndex), Groups(localIndex)))
            Next
        End SyncLock
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If m_InTimer Then
            Exit Sub
        End If
        m_InTimer = True
        Dim localAlarmData(-1) As ClassAlarmData
        SyncLock m_AlarmQueue.SyncRoot
            If m_AlarmQueue.Count > 0 Then
                ReDim localAlarmData(m_AlarmQueue.Count - 1)
                m_AlarmQueue.CopyTo(localAlarmData, 0)
                m_AlarmQueue.Clear()
            End If
        End SyncLock
        Dim localIndex As Int32
        Dim localStringBuilder As New Text.StringBuilder

        For localIndex = 0 To localAlarmData.GetLength(0) - 1
            Try
                If TextBoxValues.Text.Length > (TextBoxValues.MaxLength - 100) Then
                    TextBoxValues.Text = ""
                End If
                localStringBuilder.Append(localAlarmData(localIndex).AlarmTime.ToString("MM/DD/YYYY HH:mm:ss.fff"))
                localStringBuilder.Append(" ")
                localStringBuilder.Append(localAlarmData(localIndex).AlarmID)
                localStringBuilder.Append(" ")
                localStringBuilder.Append(localAlarmData(localIndex).AlarmType)
                localStringBuilder.Append(" ")
                If localAlarmData(localIndex).Active Then
                    localStringBuilder.Append("Active ")
                Else
                    localStringBuilder.Append("Not Active ")
                End If
                If localAlarmData(localIndex).Acked Then
                    localStringBuilder.AppendLine("Acknowledged")
                Else
                    localStringBuilder.AppendLine("Not Acknowledged")
                End If
                localStringBuilder.AppendLine(localAlarmData(localIndex).Message)

                TextBoxValues.AppendText(localStringBuilder.ToString)
                localStringBuilder.Clear()
            Catch ex As Exception
                TextBoxValues.AppendText(ex.Message)
            End Try
        Next

        m_InTimer = False
    End Sub
End Class
